# Spring 2024 Reading Group: Machine-independent complexity and formalization in theorem-provers ("Logic & Complexity" for short)

## [CU Boulder CS Theory](https://www.colorado.edu/cs-theory/theory-reading-groups)

**When:** [Mondays 1:20pm-2:20pm US Mountain Time](https://www.timeanddate.com/worldclock/converter.html?iso=20240311T192000&p1=1243) (click for time zone conversion)

**Where:** Zoom (link available for participants only)

**Prerequisites:** some knowledge of complexity theory. Having taking an undergrad or grad course in computational complexity would certainly suffice, but isn't strictly necessary. But definitely more complexity theory than the one week typically seen in an Intro Algorithms course.

**We are open to participants** with the above background and legitimate interest from anywhere. We currently have participants from CU Boulder (both [Theory](https://www.colorado.edu/cs-theory/) and [PLV](https://plv.colorado.edu/)), U. Maryland, ENS France, UIUC, and BITS Pilani. Please contact [Prof. Grochow](https://home.cs.colorado.edu/~jgrochow/) if you're interested in joining!

Many of the topics are independent from one another; where there are dependencies we've indicated that in the schedule. If you missed a session or are joining mid-semester, past sessions are recorded and available privately for participants.

----

**Schedule:**
 - 29 Jan 2024: Intro to first-order logic (with a view towards descriptive complexity) ([Josh Grochow](https://home.cs.colorado.edu/~jgrochow/)) (Resource: [Descriptive Complexity by Immerman](https://doi.org/10.1007/978-1-4612-0539-5), Sections 1.1 and 1.4)
 - 5 Feb 2024: [Blum's Axioms](https://en.wikipedia.org/wiki/Blum_axioms) ([Matthew Fox](https://www.matthewfoxphysics.com/))
 - 12 Feb 2024: [A Short Introduction to Implicity Computational Complexity by Ugo Dal Lago](https://link.springer.com/chapter/10.1007/978-3-642-31485-8_3) (Lucy Pipkorn)
 - 19 Feb 2024: Some results in descriptive complexity ([Ben Little](https://github.com/littlebenlittle)) (Will assume the 1/29 talk as background)
 - 26 Feb 2024: [RESCHEDULED due to illness] 
 - 4 Mar 2024: Intro to Lean (Tarek Tohme, ENS) (Resources: [Patrick Massot's Glimpse of Lean](https://github.com/PatrickMassot/GlimpseOfLean), see [Learning Lean 4](https://leanprover-community.github.io/learn.html) for more)
 - 11 Mar 2024: Formalizing Turing machines in Lean ([Jon Z. Cai](https://www.colorado.edu/cs/jon-z-cai)) (will assume the previous week as background)
 - 18 Mar 2024: Discussion session
 - 25 Mar 2024: NO MEETING (Spring Break)
 - 1 Apr 2024: Cancelled
 - 8 Apr 2024: [Quantum Computation as Geometry by Nielsen, Dowling, Gu, & Doherty](https://doi.org/10.1126/science.1121541) ([arXiv](https://arxiv.org/abs/quant-ph/0603161)) ([Matthew Fox](https://www.matthewfoxphysics.com/))
 - 15 Apr 2024: [Accattoli & Dal Lago. Beta Reduction is Invariant, Indeed](https://arxiv.org/abs/1405.3311) (Lucy Pipkorn)
 - 22 Apr 2024: Realizability theory
 - 29 Apr 2024: Type-enforced polynomial-time computation (will assume previous week's talk as background)
 - 6 May 2024: [One Complexity Theorist's View of Quantum Computing by Fortnow](https://doi.org/10.1016/S1571-0661(05)80330-5) ([arXiv](https://arxiv.org/abs/quant-ph/0003035)) (Tarek Tohme, ENS)